using System.Web.UI;
using System.Web.UI.WebControls;

namespace PS.WebParts.Rollup.GridViewWebPart
{
    public class TextColumn
        : FormattedColumn
    {
        internal override string GetFormatedString(object container)
        {
            object value = DataBinder.GetPropertyValue(container, DataField);

            return null == value ? string.Empty : value.ToString();
        }

        protected override DataControlField CreateField()
        {
            return new NumberColumn();
        }
    }
}
