
namespace PS.WebParts.Rollup.GridViewWebPart
{
    internal static class Constants
    {
        // This can't be done using reflection because it needs to be a constant
#if v14
        public const string DataSourceString
           =
@"<%@ Register TagPrefix='wpns1' Namespace='PS.WebParts' Assembly='PS.WebParts.Rollup, Version=14.0.0.0, Culture=neutral, PublicKeyToken=90e3045b123af1c3' %>
<wpns1:CrossSiteDataSource 
    runat='server' Scope='Recursive' DatesInISO8601='True' FixLookups='True' Lists='100' 
    QueryRowLimit='100' ContentType='Item' ID='DSC' TopLevelSite='/' IncludeListData='true'>
<Fields>
    <FieldRef Name='Title' /><FieldRef Name='Editor' /><FieldRef Name='Modified' />
</Fields>
<Query></Query>
</wpns1:CrossSiteDataSource>";
#else
        public const string DataSourceString 
            =
@"<%@ Register TagPrefix='wpns1' Namespace='PS.WebParts' Assembly='PS.WebParts.Rollup, Version=12.0.0.0, Culture=neutral, PublicKeyToken=90e3045b123af1c3' %>
<wpns1:CrossSiteDataSource 
    runat='server' Scope='Recursive' DatesInISO8601='True' FixLookups='True' Lists='100' 
    QueryRowLimit='100' ContentType='Item' ID='DSC' TopLevelSite='/' IncludeListData='true'>
<Fields>
    <FieldRef Name='Title' /><FieldRef Name='Editor' /><FieldRef Name='Modified' />
</Fields>
<Query></Query>
</wpns1:CrossSiteDataSource>";
#endif


        public const string ColumnsScheme = @"<ColumnCollection xmlns='ColumnsScheme' />";
    }
}
