using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Xml.Serialization;
using Microsoft.SharePoint.WebControls;

namespace PS.WebParts.Rollup.GridViewWebPart
{
    [XmlRoot(Namespace = "ColumnsScheme")]
    public class ColumnCollection
    {
        [XmlElement(Type = typeof(BoundField))]
        [XmlElement(Type = typeof(SPBoundField))]
        [XmlElement(Type = typeof(SPMenuField))]
        [XmlElement(Type = typeof(TextColumn))]
        [XmlElement(Type = typeof(DateTimeColumn))]
        [XmlElement(Type = typeof(NumberColumn))]
        [XmlElement(Type = typeof(BooleanColumn))]
        [XmlElement(Type = typeof(UserColumn))]
        [XmlElement(Type = typeof(DynamicColumn))]
        public List<DataControlField> Columns = new List<DataControlField>();
    };
}
