﻿using System.Xml.Serialization;

namespace PS.WssSync
{    
    public abstract class Filter
    {
        protected Filter()
        {
        }

        protected Filter(string data)
        {
            Data = data;
        }

        private string data = string.Empty;

        [XmlText]
        public string Data
        {
            get { return data; }
            set { data = value; }
        }
    }

    public class Extension : Filter
    {
        public Extension()
        {
        }

        public Extension(string data) : base(data)
        {
        }
    }

    public class Folder : Filter
    {
        public Folder()
        {
        }

        public Folder(string data) : base(data)
        {
        }
    }

    public class Regexp : Filter
    {
        public Regexp()
        {
        }

        public Regexp(string data) : base(data)
        {
        }
    }
}
