﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using PS.Config;

namespace PS.Config.Test
{
    class Program
    {
        static void Main(string[] args)
        {
            using (var site = new SPSite("http://sp2010"))
            using (SPWeb web = site.OpenWeb())
            {
                //Optional initialization. Defaults to SPContext.Current.Site.RootWeb otherwise
                Controller.Init(web);

                Console.WriteLine("Links:");
                Console.WriteLine(Controller.Current.Links.MembershipProviderService);
                Console.WriteLine(Controller.Current.Links.RoleProviderService);
                Console.WriteLine("\nEmail:");
                Console.WriteLine(Controller.Current.Email.SMTP);
                Console.WriteLine(Controller.Current.Email.User);
                Console.WriteLine(Controller.Current.Email.Password);
            }
        }
    }
}
