﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint;

namespace Tests
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnSiteDataQuery_Click(object sender, EventArgs e)
        {
            using (SPSite site = new SPSite("http://psdreznick02.dev.portalsolutions.local"))
            {
                using (SPWeb web = site.OpenWeb())
                {
                    SPSiteDataQuery siteDataQuery = new SPSiteDataQuery();

                    //siteDataQuery.Query = "<Where><Eq><FieldRef Name='ContentType' /><Value Type='Text'>Client</Value></Eq></Where>";

                    siteDataQuery.Lists = "<Lists MaxListLimit=\"0\" Hidden=\"TRUE\" ServerTemplate=\"10051\" />";

                    siteDataQuery.ViewFields = "<FieldRef Name=\"Title\" /><FieldRef Name=\"FileDirRef\" /><FieldRef Name=\"ContentType\" /><FieldRef Name=\"ClientNumber\" /><FieldRef Name=\"ReznickOffice\" /><FieldRef Name=\"PartnerInCharge\" />";

                    siteDataQuery.Webs = "<Webs Scope=\"Recursive\" />";
                    //siteDataQuery.Webs = "<Webs Scope=\"Web\" />";

                    DataTable dtResults = web.GetSiteData(siteDataQuery);
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            btnSiteDataQuery_Click(this, e);
        }
    }
}
