#region using

using System;
using System.Web.UI;
using System.Web.UI.WebControls;

#endregion

namespace PS.WebParts.Rollup.CalendarWebPart
{
    public class CalendarControl 
        : UserControl
    {
        private string direction;
        private CalendarViewType viewName;
        private string previosDate;
        private string nextDate;
        private String selectedDate;

        protected Repeater tabControl;

        #region Properties

        public string Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public CalendarViewType ViewName
        {
            get { return viewName; }
            set { viewName = value; }
        }

        public CalendarViewType MonthViewName
        {
            get { return CalendarViewType.Month; }
        }
        
        public string PreviousDate
        {
            get { return previosDate; }
            set { previosDate = value; }
        }

        public string NextDate
        {
            get { return nextDate; }
            set { nextDate = value; }
        }

        public String SelectedDate
        {
            get { return selectedDate; }
            set { selectedDate = value; }
        }

        #endregion

        protected override void CreateChildControls()
        {
            base.CreateChildControls();
            
            tabControl.DataSource = Enum.GetNames(typeof(CalendarViewType));
            tabControl.DataBind();
        }
    }
}
