using System;
using System.Diagnostics;

namespace PS.WebParts.Rollup.Query
{
    internal struct FieldItem
    {
        public FieldItem(Guid id, string name, string columnName, string type) 
            : this()
        {
            Id = id;
            Name = name;
            ColumnName = columnName;
            Type = type;
        }

        public string Name { get; set; }

        public string ColumnName { get; set; }

        public string Type { get; set; }

        public Guid Id { get; set; }
    }

    public class UserField
    {
        public string Name { get; set; }

        public string ColumnnName { get; set; }

        public string ID { get; set; }
    }

    public class LookupField : UserField
    {
        public string SourceListId { get; set; }

        public string SourceListField { get; set; }
    }
}