using System;

namespace PS.WebParts.Rollup.Query
{
    [Flags]
    public enum IncludeMetaDataOptions
    {
        Web = 1,
        List = 2,
        Item = 4,
        IDs = 16
    }

    public class PSSiteDataRollupOptions
    {
        //private bool datesInIso8601;
        private bool fixLookups;
        private bool dataAsStrings;
        private IncludeMetaDataOptions includeListData;


        //public bool DatesInIso8601
        //{
        //    get { return datesInIso8601; }
        //    set { datesInIso8601 = value; }
        //}

        public bool FixLookups
        {
            get { return fixLookups; }
            set { fixLookups = value; }
        }

        public bool DataAsStrings
        {
            get { return dataAsStrings; }
            set { dataAsStrings = value; }
        }

        //bitmask, combination of IncludeListData enum values
        public IncludeMetaDataOptions IncludeListData
        {
            get { return includeListData; }
            set { includeListData = value; }
        }
    }
}
