
namespace PS.WebParts.Rollup
{
    class Strings
    {

        public const string ParameterBindings = @"                                             <ParameterBinding Name=""dvt_apos"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""UserID"" Location=""CAMLVariable"" DefaultValue=""CurrentUserName""/>
                                                                                          <ParameterBinding Name=""Today"" Location=""CAMLVariable"" DefaultValue=""CurrentDate""/>
                                                                                          <ParameterBinding Name=""dvt_firstrow"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_nextpagedata"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_adhocmode"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_adhocfiltermode"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_filterfield"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_filtertype"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_filterval"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_groupdir"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_groupdisplay"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_groupfield"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_groupsorttype"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_grouptype"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_sortdir"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_sortfield"" Location=""Postback;Connection""/>
                                                                                          <ParameterBinding Name=""dvt_sorttype"" Location=""Postback;Connection""/>
";



        public const string XSL= @"<xsl:stylesheet xmlns:x=""http://www.w3.org/2001/XMLSchema"" xmlns:d=""http://schemas.microsoft.com/sharepoint/dsp"" version=""1.0"" exclude-result-prefixes=""xsl msxsl ddwrt"" xmlns:ddwrt=""http://schemas.microsoft.com/WebParts/v2/DataView/runtime"" xmlns:asp=""http://schemas.microsoft.com/ASPNET/20"" xmlns:__designer=""http://schemas.microsoft.com/WebParts/v2/DataView/designer"" xmlns:xsl=""http://www.w3.org/1999/XSL/Transform"" xmlns:msxsl=""urn:schemas-microsoft-com:xslt"" xmlns:SharePoint=""Microsoft.SharePoint.WebControls"" xmlns:ddwrt2=""urn:frontpage:internal"">
	<xsl:output method=""html"" indent=""no""/>
					<xsl:param name=""dvt_apos"">'</xsl:param>
					<xsl:variable name=""dvt_1_automode"">0</xsl:variable>
					<xsl:template match=""/"">
						<xsl:call-template name=""dvt_1""/>
	</xsl:template>
					<xsl:template name=""dvt_1"">
						<xsl:variable name=""dvt_StyleName"">Table</xsl:variable>
						<xsl:variable name=""Rows"" select=""/dsQueryResponse/NewDataSet/Row""/>
		<table border=""0"" width=""100%"" cellpadding=""2"" cellspacing=""0"">
			<tr valign=""top"">
				<xsl:if test=""$dvt_1_automode = '1'"" ddwrt:cf_ignore=""1"">
					<th class=""ms-vh"" width=""1%"" nowrap=""nowrap""></th>
				</xsl:if>
				<th class=""ms-vh"" nowrap=""nowrap"">Title</th>
			</tr>
			<xsl:call-template name=""dvt_1.body"">
				<xsl:with-param name=""Rows"" select=""$Rows""/>
			</xsl:call-template>
		</table>
	</xsl:template>
					<xsl:template name=""dvt_1.body"">
						<xsl:param name=""Rows""/>
						<xsl:for-each select=""$Rows"">
							<xsl:call-template name=""dvt_1.rowview""/>
		</xsl:for-each>
	</xsl:template>
					<xsl:template name=""dvt_1.rowview"">
		<tr>
			<xsl:if test=""position() mod 2 = 1"" ddwrt:cf_ignore=""1"">
				<xsl:attribute name=""class"">ms-alternating</xsl:attribute>
			</xsl:if>
			<xsl:if test=""$dvt_1_automode = '1'"" ddwrt:cf_ignore=""1"">
				<td class=""ms-vb"" width=""1%"" nowrap=""nowrap"">
					<span ddwrt:amkeyfield=""ID"" ddwrt:amkeyvalue=""ddwrt:EscapeDelims(string(@ID))"" ddwrt:ammode=""view""></span>
				</td>
			</xsl:if>
			<td class=""ms-vb"">
				<xsl:value-of select=""@Title""/>
			</td>
		</tr>
	</xsl:template>
</xsl:stylesheet>";
    }
}
